/***********************************************************
*                       pC/SFS 1.14b                       *
*            a FREE - small Serial File System             *
*                                                          *
*           by Frank Goetze  -  www.embedded-os.de         *
************************************************************
* Permission to use, copy, modify, and distribute this     *
* software in source and binary forms and its              *
* documentation for any purpose and without fee is hereby  *
* granted, provided that the above authors notice appear   *
* in all copies and that both that authors notice and this *
* permission notice appear in supporting documentation.    *
*                                                          *
* THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND   *
* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT    *
* LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY    *
* AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.     *
* IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY DIRECT,  *
* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR             *
* CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,    *
* PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF     *
* USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER *
* CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN        *
* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING           *
* NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE   *
* USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY *
* OF SUCH DAMAGE.                                          *
************************************************************
*                  SFS_LLdriver_ROimage.c                  *
*              lowlevel read-only image driver             *
*             (to split lowlevel & HW specific)            *
************************************************************
* Revision-Info:                                           *
*                                                          *
***********************************************************/

#include "../../inc/pC_SFS.h"

#include "_ROimages/SFS_image.h"

#if !defined(SFS_MEM_ROimage_Port)
 #error "wrong config for the ROM image SFS-port!"
#endif
/*
#if (SFS_IMAGE_bin_size != SFS_MEMORY_SIZE)
 #error "wrong size of the ROM image SFS-port!"
#endif
*/
/**********************************************************
 *   using an code array as memory
 *   (work on const[] as r/o-filesystem)
 *
 *   SFS_MEMORY_START [ SFS_MEMORY_SIZE ]
 *
 **********************************************************/
extern const U08 SFS_MEMORY_START[SFS_MEMORY_SIZE];

/*
************************************************************
*                     INIT ROM array
************************************************************
*/
U08 SFSPort_Init(void)
{
    return(SFS_NO_ERR);
}

/*
************************************************************
*                    READ FROM ROM
************************************************************
*/
U08 SFSPort_Read(U32 offs, U08 OS_HUGE *dest, SFS_LONG length) KC51_REENTRANT
{
    SFS_LONG i = 0;

    sfsPort_lock();
    while(i < length) { dest[i] = ((U08 *)SFS_MEMORY_START)[offs + i]; i++; }
    sfsPort_unlock();
    return(SFS_NO_ERR);
}

/*
************************************************************
*                    WRITE INTO ROM (dummy)
************************************************************
*/
U08 SFSPort_Write(U32 offs, U08 OS_HUGE *source, SFS_LONG length) KC51_REENTRANT
{
    return(SFS_NO_ERR);
}

/*
************************************************************
*                        FILL ROM (dummy)
************************************************************
*/
U08 SFSPort_Fill(U32 offs, U08 value, SFS_LONG length) KC51_REENTRANT
{
    return(SFS_NO_ERR);
}

/************************* END ****************************/
